/* MKPASSWD v2.0 - Chris Wolkowski */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

extern char *getpass();

int main(argc, argv)
int argc;
char *argv[];
{
  static char saltChars[] = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789./";
  char salt[3];
  char * plaintext;
  int i;

  if (argc < 2) {
    srandom(time(0));		/* may not be the BEST salt, but its close */
    salt[0] = saltChars[random() % 64];
    salt[1] = saltChars[random() % 64];
    salt[2] = 0;
  }
  else {
    salt[0] = argv[1][0];
    salt[1] = argv[1][1];
    salt[2] = '\0';
    if ((strchr(saltChars, salt[0]) == NULL) || (strchr(saltChars, salt[1]) == NULL))
	printf (" ____________________________________________ \n");
	printf ("|                *** ERROR ***                \n");
	fprintf(stderr, "| Illegal salt %s\n", salt), exit(1);
	printf ("|____________________________________________ \n");
  }

	printf (" ____________________________________________ \n");
	plaintext = getpass("| Enter Password: ");
	printf ("|                                             \n");
	printf ("| Encryption: %s                              \n", crypt(plaintext, salt));
	printf ("|____________________________________________ \n");
	printf ("| You can encrypt passwords on your elite irc \n");
	printf ("| server. Syntax: /MKPASSWD <word>            \n");
	printf ("|____________________________________________ \n");

  return 0;
}
